> ## Documentation Index
> Fetch the complete documentation index at: https://docs.mangopay.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a Dispute Document

### Path parameters

<ParamField path="DisputeId" type="string" required>
  The unique identifier of the dispute.
</ParamField>

### Body parameters

<ParamField body="Type" type="string" required>
  **Allowed values:** `DELIVERY_PROOF`, `INVOICE`, `REFUND_PROOF`, `USER_CORRESPONDANCE`, `USER_ACCEPTANCE_PROOF`, `PRODUCT_REPLACEMENT_PROOF`, `OTHER`

  The type of the dispute document.
</ParamField>

<ParamField body="Tag" type="string">
  Max. length: 255 characters

  Custom data that you can add to this object.
</ParamField>

### Responses

<AccordionGroup>
  <Accordion title="200">
    <ResponseField name="DisputeId" type="string">
      The unique identifier of the dispute.
    </ResponseField>

    <ResponseField name="Type" type="string">
      **Returned values:** `DELIVERY_PROOF`, `INVOICE`, `REFUND_PROOF`, `USER_CORRESPONDANCE`, `USER_ACCEPTANCE_PROOF`, `PRODUCT_REPLACEMENT_PROOF`, `OTHER`

      The type of the dispute document.
    </ResponseField>

    <ResponseField name="Id" type="string">
      Max length: 128 characters (see [data formats](/api-reference/overview/data-formats) for details)

      The unique identifier of the object.
    </ResponseField>

    <ResponseField name="Tag" type="string">
      Max. length: 255 characters

      Custom data that you can add to this object.
    </ResponseField>

    <ResponseField name="CreationDate" type="Unix timestamp">
      The date and time at which the object was created.
    </ResponseField>

    <ResponseField name="ProcessedDate" type="Unix timestamp">
      The date and time at which the document was processed by Mangopay’s team.
    </ResponseField>

    <ResponseField name="Status" type="string">
      **Returned values:** `CREATED`, `VALIDATION_ASKED`, `VALIDATED`, `REFUSED`, `OUT_OF_DATE`

      The status of the dispute document.
    </ResponseField>

    <ResponseField name="RefusedReasonType" type="string">
      **Returned values:** DOCUMENT\_DO\_NOT\_MATCH\_USER\_DATA, DOCUMENT\_FALSIFIED, DOCUMENT\_HAS\_EXPIRED, DOCUMENT\_INCOMPLETE, DOCUMENT\_MISSING, DOCUMENT\_NOT\_ACCEPTED, DOCUMENT\_UNREADABLE, SPECIFIC\_CASE, UNDERAGE\_PERSON

      The reason for the dispute document refusal. See the <inline-code>RefusedReasonMessage</inline-code> for more information.
    </ResponseField>

    <ResponseField name="RefusedReasonMessage" type="string">
      Max. length: 255 characters

      **Default value:** null

      Additional information about why the dispute document was refused, provided by Mangopay’s team.
    </ResponseField>
  </Accordion>
</AccordionGroup>

<ResponseExample>
  ```json 200 theme={null}
  {
      "DisputeId": "159102965",
      "Type": "DELIVERY_PROOF",
      "Id": "159188418",
      "Tag": null,
      "CreationDate": 1672655973,
      "ProcessedDate": null,
      "Status": "CREATED",
      "RefusedReasonType": null,
      "RefusedReasonMessage": null
  }  
  ```
</ResponseExample>

<RequestExample>
  ```json REST   theme={null}
  {
      "Type": "DELIVERY_PROOF",
      "Tag": "Custom meta"
  }  
  ```

  ```php PHP theme={null}
  <?php 

  require_once 'vendor/autoload.php';

  use MangoPay\MangoPayApi;
  use MangoPay\Libraries\ResponseException as MGPResponseException;
  use MangoPay\Libraries\Exception as MGPException;

  $api = new MangoPayApi();

  $api->Config->ClientId = 'your-client-id';
  $api->Config->ClientPassword = 'your-api-key';
  $api->Config->TemporaryFolder = 'tmp/';

  ry {
      $disputeId = '199385842';

      $document = new \MangoPay\DisputeDocument();
      $document->Type = \MangoPay\DisputeDocumentType::DeliveryProof;
      $document->Tag = 'Created using Mangopay PHP SDK';

      
      $response = $api->Disputes->CreateDisputeDocument($disputeId, $document);

      print_r($response);
  } catch(MGPResponseException $e) {
      print_r($e);
  } catch(MGPException $e) {
      print_r($e);
  }  
  ```

  ```javascript NodeJS   theme={null}
  const mangopayInstance = require('mangopay4-nodejs-sdk')
  const mangopay = new mangopayInstance({
    clientId: 'your-client-id',
    clientApiKey: 'your-api-key',
  })

  let myDispute = {
    Id: '172969213',
  }

  let myDisputeDocument = {
    Type: 'DELIVERY_PROOF',
    Tag: 'Created using Mangopay Node.js SDK',
  }

  const createDisputeDocument = async (disputeId, disputeDocument) => {
    return await mangopay.Disputes.createDisputeDocument(disputeId, disputeDocument)
      .then((response) => {
        console.info(response)
        return response
      })
      .catch((err) => {
        console.log(err)
        return false
      })
  }

  createDisputeDocument(myDispute.Id, myDisputeDocument)  
  ```

  ```java Java  theme={null}
  import com.google.gson.Gson;
  import com.google.gson.GsonBuilder;
  import com.mangopay.MangoPayApi;
  import com.mangopay.core.enumerations.DisputeDocumentType;
  import com.mangopay.entities.DisputeDocument;

  public class CreateDisputeDoc {
      public static void main(String[] args) throws Exception {
          MangoPayApi mangopay = new MangoPayApi();
          mangopay.getConfig().setClientId("your-client-id");
          mangopay.getConfig().setClientPassword("your-api-key");
          
          var disputeId = "dispute_m_01J354MZ17XZA4DMAQS1766VXM";
          DisputeDocument disputeDocument = new DisputeDocument();
          disputeDocument.setDisputeId(disputeId);
          disputeDocument.setType(DisputeDocumentType.DELIVERY_PROOF);

          DisputeDocument createDisputeDoc = mangopay.getDisputeApi().createDisputeDocument(disputeDocument, disputeId);

          Gson prettyPrint = new GsonBuilder().setPrettyPrinting().create();
          String prettyJson = prettyPrint.toJson(createDisputeDoc);

          System.out.println(prettyJson);
      
      }  
  }
  ```

  ```ruby Ruby   theme={null}
  require 'mangopay'

  MangoPay.configure do |client|
      client.preproduction = true
      client.client_id = 'your-client-id'
      client.client_apiKey = 'your-api-key'
      client.log_file = File.join(Dir.pwd, 'mangopay.log')
  end

  def createDisputeDocument(disputeId, disputeDocumentObject)
      begin
          response = MangoPay::Dispute.create_document(disputeId, disputeDocumentObject)
          puts response
          return response
      rescue MangoPay::ResponseError => error
          puts "Failed to create Document: #{error.message}"
          puts "Error details: #{error.details}"
          return false
      end
  end

  myDispute = {
      Id:'194413022'
  }

  myDocument = {
      Type:'DELIVERY_PROOF',
      Tag:'Created using Mangopay Ruby SDK'
  }

  createDisputeDocument(myDispute[:Id], myDocument)  
  ```

  ```csharp .NET  theme={null}
  using MangoPay.SDK;
  using MangoPay.SDK.Core.Enumerations;
  using MangoPay.SDK.Entities.POST;
  using Newtonsoft.Json;

  class Program
  {
      static async Task Main(string[] args)
      {
          MangoPayApi api = new MangoPayApi();

          api.Config.ClientId = "your-client-id";
          api.Config.ClientPassword = "your-api-key";

          var disputeId = "dispute_m_01J41GEVRQN3W1C4YRK7NC04QT";
          
          DisputeDocumentPostDTO disputeDoc = new DisputeDocumentPostDTO(DisputeDocumentType.INVOICE);

          var createDisputeDocument = await api.Disputes.CreateDisputeDocumentAsync(disputeDoc, disputeId);

          string prettyPrint = JsonConvert.SerializeObject(createDisputeDocument, Formatting.Indented);
          Console.WriteLine(prettyPrint);
      }
  }
  ```
</RequestExample>
